#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Dec 12 13:47:48 2017

@author: lessig
"""

import numpy as np
import matplotlib.pyplot as plt

from plane import Plane
from sphere import Sphere
from object import Object
from diffuse import Diffuse
from phong import Phong
from mirror import Mirror
from render import render


# define scene
plane = Object( Plane( np.array([0, 1, 0]), np.array([0, -1., 0])),
                Diffuse( np.array([0.8, 0.2, 0.2])))
sphere = Object( Sphere(np.array([0, 0, 7.]), 1.), 
                 Phong( 16, np.array([0.2, 0.7, 0.2])))
light = Object( Plane(np.array([0, 0., -1]), np.array([0, 10., 0])), 
                 Diffuse( np.array([0.8, 0.2, 0.2])),
                 10.0)
scene= [plane, sphere, light]

# render
im = render( 512, 512, scene, 4)

# display result
imdisplay = np.clip( im / (np.max(im)), 0., 1.0)
plt.imshow( np.flip( np.transpose(imdisplay,(1,0,2)), 0))
image = plt.show()
plt.imsave( 'image.png', imdisplay)
