#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Dec 18 14:20:05 2018

@author: lessig
"""

import numpy as np


def s2tor3( theta, phi) :
    x = np.sin(theta) * np.cos(phi)
    y = np.sin(theta) * np.sin(phi)
    z = np.cos(theta)
    return np.array( [x, y, z])


def getRotationLocalGlobal( normal):
    
    xvec = np.array( [1, 0, 0])
    if( np.linalg.norm( xvec - normal) < 0.0001) :
        xvec = np.array( [1, 1, 0]) / np.sqrt( 2)
    # remove normal component
    xvec = xvec - np.dot( xvec, normal) * normal
    xvec = xvec / np.linalg.norm( xvec)
    assert np.dot( xvec, normal) < 100.0 * np.finfo(np.dtype(xvec[0])).eps
    
    yvec = np.cross( normal, xvec)
    
    Rt = np.array( [xvec, yvec, normal])
    return np.transpose( Rt)
